<?php

namespace Modules\Sector\Requests\Employee;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\Sector\Services\SectorService;
use Modules\User\Enums\UserRoleEnum;

class SectorRequest extends FormRequest
{
    public function __construct(
        private SectorService $sectorService,
    ){}

    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        $role = UserRoleEnum::employees();
        if (! Auth::check()) {
            return false;
        }
        if(!in_array(Auth::user()->role, $role))
        {
            return false;
        }
        if(Auth::user()->hasModule('sectors'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $sector = $this->sectorService->checkItem($this->sector ?? 0 );
        if($sector)
        {
            if($sector->lock)
            {
                return [
                    'locked'=>'required'
                ];
            }
        }
        $rules = [];

        foreach (languages() as $lang)
        {
            $lang_rules=[
                'title_'.$lang->local=> 'required|max:50',
                'description_'.$lang->local=> 'nullable|max:150',
            ];
            $rules= array_merge($rules, $lang_rules);
        }


        return $rules;
    }

    public function messages()
    {
        return [
            'locked.required'=>__('dashboard.locked'),
        ];
    }
    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [];
        $languages = languages();
        foreach ($languages as $lang) {
            $lang_attributes=[
                'title_'.$lang->local => __('sectors.title') . (count($languages) > 1 ? ' '.$lang->local : '' ),
                'description_'.$lang->local => __('sectors.description') . (count($languages) > 1 ? ' '.$lang->local : '' ),
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
